;
;		(c) 2008, ..,   .   (   )
;
;	   0x74   I2C.    :
;		- 0b00000000	-  
;		- 0b00010001	-  .
;		- 0b00010010	-      .
;		- 0b00010011	-      .
;		- 0b00100nnn	-  (nnn -    - ,  ,   ).
;
;	  :
;		PB[0] -   ()
;		PB[1] -  SCL ()
;		PB[2] -  SDA ()
;		PB[3] -  + ()
;		PB[4] -   ()
;		PB[5] -  + () -   !
;
;	 :
;
;		r16 	-    .
;		r17		-   I2C   .
;		r19		-    .
;		r20		-    
;		r24		- 0 -   . 1 -  .
;
;	 1.0
;
;		http://chav1961.narod.ru
;		E-Mail chav1961@mail.ru
;

.include "tn15def.inc"
			.equ		SCL=PB1			;       .
			.equ		SDA=PB2
			.equ		LCD1=PB0
			.equ		LCD2=PB4
			.equ		LCD3=PB3
			.equ		LCD4=5
			.equ		ADDRESS=0x74

			.macro		SCL_ON			;  .1  SCL
L:			sbis		PINB,SCL
			rjmp		L
			.endm
			.macro		SCL_OFF			;  .0  SCL
L:			sbic		PINB,SCL
			rjmp		L
			.endm
			.macro		SDA_ON			;  .1  SDA
L:			sbis		PINB,SDA
			rjmp		L
			.endm
			.macro		SDA_OFF			;  .0  SDA
L:			sbic		PINB,SDA
			rjmp		L
			.endm


start:		rjmp		begin		;    .
			rjmp 		_EXT_INT0 	;  .
			rjmp 		_PIN_CHANGE ;      .
			rjmp 		_TIM1_CMP 	;   1  OCR
			rjmp 		_TIM1_OVF 	;   1
			rjmp 		_TIM0_OVF 	;   0
			rjmp 		_EE_RDY 	;  
			rjmp 		_ANA_COMP 	;  
			rjmp 		_ADC 		;   

;			 :
begin:		ldi			r16,0x80
			out			OSCCAL,r16	;   
			ldi			r16,(1<<LCD1)|(1<<LCD2)|(1<<LCD3)	; 1<<LCD4  , ..       !
			out			DDRB,r16	;       B.
			ldi			r19,(1<<scl)|(1<<SDA)|(1<<LCD1)|(1<<LCD2)|(1<<LCD3)|(1<<LCD4)

;			    I2C
b00:		out			PORTB,r19	;  - /   PB5 ( RESET)    PORTB,   DDRB!
			sbrs		r19,LCD4
			sbi			DDRB,LCD4
			sbrc		r19,LCD4
			cbi			DDRB,LCD4
			ldi			r16,8		;  8 .
			ldi			r24,1		;  ...
			SDA_OFF
			SCL_OFF
b01:		lsl			r17			;   .
			SCL_ON
			sbic		PINB,SDA	;  .   .1  SDA
			inc			r17
			SCL_OFF
			dec			r16			;    .
			brne		b01			;    !
			cpi			r17,ADDRESS	;       ?
			breq		f01			; !
			ldi			r24,0		;  -   ...
			SCL_ON
			SCL_OFF
			rjmp		b03a
f01:		cbi			PORTB,SDA	;   .
			sbi			DDRB,SDA
			SCL_ON
			SCL_OFF
			cbi			DDRB,SDA
			sbi			PORTB,SDA
b03a:		ldi			r16,8		;    ...
b03:		lsl			r17			;   .
			SCL_ON
			sbic		PINB,SDA	;  .   .1  SDA
			inc			r17
			SCL_OFF
			dec			r16			;    .
			brne		b03			;    !
			cpi			r24,1		;   -  ?
			breq		b031		;  -   ...
			SCL_ON					;  -  ...
			SCL_OFF
			rjmp		b04
b031:		cbi			PORTB,SDA	;   .
			sbi			DDRB,SDA
			SCL_ON
			SCL_OFF
			cbi			DDRB,SDA
			sbi			PORTB,SDA
b04:		SCL_ON
			SDA_ON

;			  :
f02:		cpi			r24,1		;  -  ?
			breq		x00			;  -  ...
			rjmp		b00			;  -   .
x00:		sbrc		r17,4
			rjmp		x01			;  -      .
			sbrc		r17,5
			rjmp		x02			;       .
			cli						;  -  ,   ...
			rjmp		begin
x01:		sbrs		r17,1
			rjmp		x011		;    .
			ldi			r19,(1<<LCD1)|(1<<LCD2)|(1<<LCD3)|(1<<LCD4)
			sbrc		r17,0		;    ,    .
			eor			r19,r20		;  .
			sbrs		r17,0
			and			r19,r20		;   .
			sbr			r19,0b00000110
			rjmp		b00
x011:		ldi			r19,(1<<scl)|(1<<SDA)|(1<<LCD1)|(1<<LCD2)|(1<<LCD3)|(1<<LCD4)
			rjmp		b00
x02:		sbrc		r17,0		;      .
			ldi			r20,(1<<LCD1)
			sbrc		r17,1
			ldi			r20,(1<<LCD1)|(1<<LCD2)
			sbrc		r17,2
			ori			r20,(1<<LCD1)|(1<<LCD2)|(1<<LCD3)
			rjmp		b00


_TIM1_CMP: 	;   1  OCR
_TIM1_OVF: 	;   1
_EXT_INT0: 	;  .
_PIN_CHANGE:;      .
_TIM0_OVF: 	;   0
_EE_RDY: 	;  
_ANA_COMP: 	;  
_ADC: 		;   
			reti
		
