;
;		(c) 2008, ..,   .   ( / )
;
;	   0x70   I2C.    :
;		- 0b00000000	-  
;		- 0b00010000	-  
;		- 0b00010001	-  
;
;	  :
;		PB[0] -    ()
;		PB[1] -  SCL ()
;		PB[2] -  SDA ()
;		PB[3] -   ()
;		PB[4] -  
;
;	 :
;
;		r16 	-    .
;		r17		-   I2C   .
;		r19		-    .
;		r24		- 0 -   . 1 -  .
;
;	 1.0
;
;		http://chav1961.narod.ru
;		E-Mail chav1961@mail.ru
;

.include "tn15def.inc"
			.equ		SCL=PB1			;       .
			.equ		SDA=PB2
			.equ		LED_ON=PB3
			.equ		LED_OFF=PB0
			.equ		ADDRESS=0x70

			.macro		SCL_ON			;  .1  SCL
L:			sbis		PINB,SCL
			rjmp		L
			.endm
			.macro		SCL_OFF			;  .0  SCL
L:			sbic		PINB,SCL
			rjmp		L
			.endm
			.macro		SDA_ON			;  .1  SDA
L:			sbis		PINB,SDA
			rjmp		L
			.endm
			.macro		SDA_OFF			;  .0  SDA
L:			sbic		PINB,SDA
			rjmp		L
			.endm


start:		rjmp		begin		;    .
			rjmp 		_EXT_INT0 	;  .
			rjmp 		_PIN_CHANGE ;      .
			rjmp 		_TIM1_CMP 	;   1  OCR
			rjmp 		_TIM1_OVF 	;   1
			rjmp 		_TIM0_OVF 	;   0
			rjmp 		_EE_RDY 	;  
			rjmp 		_ANA_COMP 	;  
			rjmp 		_ADC 		;   

;			 :
begin:		ldi			r16,0x80
			out			OSCCAL,r16	;   
			ldi			r16,(1<<LED_OFF)|(1<<LED_ON)
			out			DDRB,r16	;       B.
			ldi			r19,(1<<LED_OFF)|(1<<SCL)|(1<<SDA)
			ldi			r19,0x07	;  ...

;			    I2C
b00:		out			PORTB,r19	;     .
			ldi			r16,8		;  8 .
			ldi			r24,1		;  ...
			SDA_OFF
			SCL_OFF
b01:		lsl			r17			;   .
			SCL_ON
			sbic		PINB,SDA	;  .   .1  SDA
			inc			r17
			SCL_OFF
			dec			r16			;    .
			brne		b01			;    !
			cpi			r17,ADDRESS	;       ?
			breq		f01			; !
			ldi			r24,0		;  -   ...
			SCL_ON
			SCL_OFF
			rjmp		b03a
f01:		cli						; - ,      .
			cbi			PORTB,SDA	;   .
			sbi			DDRB,SDA
			SCL_ON
			SCL_OFF
			cbi			DDRB,SDA
			sbi			PORTB,SDA
			sei
b03a:		ldi			r16,8		;    ...
b03:		lsl			r17			;   .
			SCL_ON
			sbic		PINB,SDA	;  .   .1  SDA
			inc			r17
			SCL_OFF
			dec			r16			;    .
			brne		b03			;    !
			cpi			r24,1		;   -  ?
			breq		b031		;  -   ...
			SCL_ON					;  -  ...
			SCL_OFF
			rjmp		b04
b031:		cli						; - ,      .
			cbi			PORTB,SDA	;   .
			sbi			DDRB,SDA
			SCL_ON
			SCL_OFF
			cbi			DDRB,SDA
			sbi			PORTB,SDA
			sei
b04:		SCL_ON
			SDA_ON

;			  :
f02:		cpi			r24,1		;  -  ?
			breq		x00			;  -  ...
			rjmp		b00			;  -   .
x00:		sbrc		r17,4
			rjmp		x01			;  -      .
			cli						;  -  ,   ...
			rjmp		begin
x01:		ldi			r19,(1<<SCL)|(1<<SDA)
			sbrs		r17,0		;  ,    .
			ori			r19,(1<<LED_OFF)
			sbrc		r17,0
			ori			r19,(1<<LED_ON)
			rjmp		b00


_TIM1_CMP: 	;   1  OCR
_TIM1_OVF: 	;   1
_EXT_INT0: 	;  .
_PIN_CHANGE:;      .
_TIM0_OVF: 	;   0
_EE_RDY: 	;  
_ANA_COMP: 	;  
_ADC: 		;   
			reti
		
